program project1;

{$mode objfpc}{$H+}

uses
 {$IFDEF UNIX}
  cthreads,
    {$ENDIF}
  Classes, windows,
  SysUtils,
  CustApp,
  { you can add units after this }
  MMsystem;

type

  { TMyApplication }

  TMyApplication = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
  end;

  { TMyApplication }

  procedure TMyApplication.DoRun;
  var
    ErrorMsg: string;
    sinMS: TMemoryStream;
    RiffCount, TempInt, i, ByteCount, Duration, device: integer;
    w: double;
    WaveFormatEx: TWaveFormatEx;
    SampleRate : integer = 22050;
    SoundValue: Word;
    x, y: MMRESULT;
    FWAVEOutHandle: DWORD_PTR;
  const
    Mono: word = $0001;
    RiffId: string = 'RIFF';
    WaveId: string = 'WAVE';
    FmtId: string = 'fmt ';
    DataId: string = 'data';
  begin
    // quick check parameters
    ErrorMsg := CheckOptions('h', 'help');
    if ErrorMsg <> '' then
    begin
      ShowException(Exception.Create(ErrorMsg));
      Terminate;
      Exit;
    end;

    // parse parameters
    if HasOption('h', 'help') then
    begin
      WriteHelp;
      Terminate;
      Exit;
    end;

    { add your program here }

    // Kurz nein Sinus erstellt
    sinMS := TMemoryStream.Create;

    { Wave-Format setzen }
    with WaveFormatEx do
    begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := Mono;
      nSamplesPerSec := SampleRate;
      wBitsPerSample := $0010;
      nBlockAlign := (nChannels * wBitsPerSample) div 8;
      nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
      cbSize := 0;
    end;

    // ms * sample
    Duration := (1000 * SampleRate) div 1000 ;
    ByteCount := Duration * 2;


    with sinMS do
    begin
      RiffCount := Length(WaveId) + Length(FmtId) + SizeOf(DWORD) +
        SizeOf(TWaveFormatEx) + Length(DataId) + SizeOf(DWORD) + ByteCount;

      Write(RiffId[1], 4);                        // 'RIFF'
      Write(RiffCount, SizeOf(DWORD));            // file data size
      Write(WaveId[1], Length(WaveId));           // 'WAVE'
      Write(FmtId[1], Length(FmtId));             // 'fmt '
      TempInt := SizeOf(TWaveFormatEx);
      Write(TempInt, SizeOf(DWORD));              // TWaveFormat data size
      Write(WaveFormatEx, SizeOf(TWaveFormatEx)); // WaveFormatEx record
      Write(DataId[1], Length(DataId));           // 'data'
      Write(ByteCount, SizeOf(DWORD));         // sound data size

      w := 2 * Pi * 1000;
      for i := 0 to Duration - 1 do
      begin
        //Trunc(xx <= Lautstärke 0..127
        SoundValue := 256 * (Trunc(76 * sin(i * w / SampleRate)));
        Write(SoundValue , SizeOf(word));
      end;

    end;
    //AudioTest:
    FWAVEOutHandle := 0;
    device := 2; // ändern der Variable ohne veränderung
    x := waveOutOpen(@FWAVEOutHandle, device, @WaveFormatEx, FWAVEOutHandle, 0, WAVE_ALLOWSYNC);
    sndPlaySound(sinMS.Memory, SND_MEMORY or SND_SYNC);
    y := waveOutClose(FWAVEOutHandle);

    Writeln('openResultCode:' , x, ' ,closeResultCode:', y);   
    ReadLn;


    (*   MMSYSERR_BASE = 0;
    MMSYSERR_NOERROR = 0;
    MMSYSERR_ERROR = (MMSYSERR_BASE+1);
    MMSYSERR_BADDEVICEID = (MMSYSERR_BASE+2);
    MMSYSERR_NOTENABLED = (MMSYSERR_BASE+3);
    MMSYSERR_ALLOCATED = (MMSYSERR_BASE+4);
    MMSYSERR_INVALHANDLE = (MMSYSERR_BASE+5);
    MMSYSERR_NODRIVER = (MMSYSERR_BASE+6);
    MMSYSERR_NOMEM = (MMSYSERR_BASE+7);
    MMSYSERR_NOTSUPPORTED = (MMSYSERR_BASE+8);
    MMSYSERR_BADERRNUM = (MMSYSERR_BASE+9);
    MMSYSERR_INVALFLAG = (MMSYSERR_BASE+10);
    MMSYSERR_INVALPARAM = (MMSYSERR_BASE+11);
    MMSYSERR_HANDLEBUSY = (MMSYSERR_BASE+12);
    MMSYSERR_INVALIDALIAS = (MMSYSERR_BASE+13);
    MMSYSERR_BADDB = (MMSYSERR_BASE+14);
    MMSYSERR_KEYNOTFOUND = (MMSYSERR_BASE+15);
    MMSYSERR_READERROR = (MMSYSERR_BASE+16);
    MMSYSERR_WRITEERROR = (MMSYSERR_BASE+17);
    MMSYSERR_DELETEERROR = (MMSYSERR_BASE+18);
    MMSYSERR_VALNOTFOUND = (MMSYSERR_BASE+19);
    MMSYSERR_NODRIVERCB = (MMSYSERR_BASE+20);
    MMSYSERR_LASTERROR = (MMSYSERR_BASE+20);
    *)


    sinMS.Free;
    // stop program loop
    Terminate;
  end;

  constructor TMyApplication.Create(TheOwner: TComponent);
  begin
    inherited Create(TheOwner);
    StopOnException := True;
  end;

  destructor TMyApplication.Destroy;
  begin
    inherited Destroy;
  end;

  procedure TMyApplication.WriteHelp;
  begin
    { add your help code here }
    writeln('Usage: ', ExeName, ' -h');
  end;

var
  Application: TMyApplication;
begin
  Application := TMyApplication.Create(nil);
  Application.Title := 'My Application';
  Application.Run;
  Application.Free;
end.
